=== modified file 'bzrlib/dirstate.py'
--- bzrlib/dirstate.py	2011-04-04 13:37:25 +0000
+++ bzrlib/dirstate.py	2011-04-05 11:10:25 +0000
@@ -1745,8 +1745,8 @@
                 self._sha_cutoff_time()
             if (stat_value.st_mtime < self._cutoff_time
                 and stat_value.st_ctime < self._cutoff_time):
-                entry[1][0] = ('f', sha1, stat_value.st_size, entry[1][0][3],
-                               packed_stat)
+                entry[1][0] = ('f', sha1, entry[1][0][2], entry[1][0][3],
+                    packed_stat)
                 self._dirblock_state = DirState.IN_MEMORY_MODIFIED
 
     def _sha_cutoff_time(self):

=== modified file 'bzrlib/tests/test_transform.py'
--- bzrlib/tests/test_transform.py	2011-04-04 14:47:07 +0000
+++ bzrlib/tests/test_transform.py	2011-04-05 11:10:25 +0000
@@ -161,48 +161,6 @@
         transform.finalize()
         transform.finalize()
 
-    def test_create_file_caches_sha1(self):
-        trans, root = self.get_transform()
-        self.wt.lock_tree_write()
-        self.addCleanup(self.wt.unlock)
-        content = ['just some content\n']
-        sha1 = osutils.sha_strings(content)
-        trans_id = trans.create_path('file1', root)
-        # Roll back the clock
-        transform._creation_mtime = creation_mtime = time.time() - 20.0
-        trans.create_file(content, trans_id, sha1=sha1)
-        st_val = osutils.lstat(trans._limbo_name(trans_id))
-        o_sha1, o_st_val = trans._observed_sha1s[trans_id]
-        self.assertEqual(o_sha1, sha1)
-        self.assertEqualStat(o_st_val, st_val)
-
-    def test__apply_insertions_updates_sha1(self):
-        trans, root = self.get_transform()
-        self.wt.lock_tree_write()
-        self.addCleanup(self.wt.unlock)
-        content = ['just some content\n']
-        sha1 = osutils.sha_strings(content)
-        trans_id = trans.create_path('file1', root)
-        # Roll back the clock
-        transform._creation_mtime = creation_mtime = time.time() - 20.0
-        trans.create_file(content, trans_id, sha1=sha1)
-        st_val = osutils.lstat(trans._limbo_name(trans_id))
-        o_sha1, o_st_val = trans._observed_sha1s[trans_id]
-        self.assertEqual(o_sha1, sha1)
-        self.assertEqualStat(o_st_val, st_val)
-        creation_mtime += 10.0
-        # We fake a time difference from when the file was created until now it
-        # is being renamed by using os.utime. Note that the change we actually
-        # want to see is the real ctime change from 'os.rename()', but as long
-        # as we observe a new stat value, we should be fine.
-        os.utime(trans._limbo_name(trans_id), (creation_mtime, creation_mtime))
-        trans.apply()
-        new_st_val = osutils.lstat(self.wt.abspath('file1'))
-        o_sha1, o_st_val = trans._observed_sha1s[trans_id]
-        self.assertEqual(o_sha1, sha1)
-        self.assertEqualStat(o_st_val, new_st_val)
-        self.assertNotEqual(st_val.st_mtime, new_st_val.st_mtime)
-
     def test_create_files_same_timestamp(self):
         transform, root = self.get_transform()
         self.wt.lock_tree_write()
@@ -1941,18 +1899,6 @@
         self.addCleanup(target.unlock)
         self.assertEqual([], list(target.iter_changes(revision_tree)))
 
-    def test_build_tree_accelerator_tree_observes_sha1(self):
-        source = self.create_ab_tree()
-        sha1 = osutils.sha_string('A')
-        target = self.make_branch_and_tree('target')
-        target.lock_write()
-        self.addCleanup(target.unlock)
-        state = target.current_dirstate()
-        state._cutoff_time = time.time() + 60
-        build_tree(source.basis_tree(), target, source)
-        entry = state._get_entry(0, path_utf8='file1')
-        self.assertEqual(sha1, entry[1][0][1])
-
     def test_build_tree_accelerator_tree_missing_file(self):
         source = self.create_ab_tree()
         os.unlink('source/file1')
@@ -2116,42 +2062,6 @@
         self.assertEqual('file.moved', target.id2path('lower-id'))
         self.assertEqual('FILE', target.id2path('upper-id'))
 
-    def test_build_tree_observes_sha(self):
-        source = self.make_branch_and_tree('source')
-        self.build_tree(['source/file1', 'source/dir/', 'source/dir/file2'])
-        source.add(['file1', 'dir', 'dir/file2'],
-                   ['file1-id', 'dir-id', 'file2-id'])
-        source.commit('new files')
-        target = self.make_branch_and_tree('target')
-        target.lock_write()
-        self.addCleanup(target.unlock)
-        # We make use of the fact that DirState caches its cutoff time. So we
-        # set the 'safe' time to one minute in the future.
-        state = target.current_dirstate()
-        state._cutoff_time = time.time() + 60
-        build_tree(source.basis_tree(), target)
-        entry1_sha = osutils.sha_file_by_name('source/file1')
-        entry2_sha = osutils.sha_file_by_name('source/dir/file2')
-        # entry[1] is the state information, entry[1][0] is the state of the
-        # working tree, entry[1][0][1] is the sha value for the current working
-        # tree
-        entry1 = state._get_entry(0, path_utf8='file1')
-        self.assertEqual(entry1_sha, entry1[1][0][1])
-        # The 'size' field must also be set.
-        self.assertEqual(25, entry1[1][0][2])
-        entry1_state = entry1[1][0]
-        entry2 = state._get_entry(0, path_utf8='dir/file2')
-        self.assertEqual(entry2_sha, entry2[1][0][1])
-        self.assertEqual(29, entry2[1][0][2])
-        entry2_state = entry2[1][0]
-        # Now, make sure that we don't have to re-read the content. The
-        # packed_stat should match exactly.
-        self.assertEqual(entry1_sha, target.get_file_sha1('file1-id', 'file1'))
-        self.assertEqual(entry2_sha,
-                         target.get_file_sha1('file2-id', 'dir/file2'))
-        self.assertEqual(entry1_state, entry1[1][0])
-        self.assertEqual(entry2_state, entry2[1][0])
-
 
 class TestCommitTransform(tests.TestCaseWithTransport):
 

=== modified file 'bzrlib/transform.py'
--- bzrlib/transform.py	2011-04-04 14:47:07 +0000
+++ bzrlib/transform.py	2011-04-05 11:10:25 +0000
@@ -19,6 +19,7 @@
 from stat import S_ISREG, S_IEXEC
 import time
 
+import bzrlib
 from bzrlib import (
     errors,
     lazy_import,
@@ -104,8 +105,6 @@
         self._new_parent = {}
         # mapping of trans_id with new contents -> new file_kind
         self._new_contents = {}
-        # mapping of trans_id => (sha1 of content, stat_value)
-        self._observed_sha1s = {}
         # Set of trans_ids whose contents will be removed
         self._removed_contents = set()
         # Mapping of trans_id -> new execute-bit value
@@ -1250,19 +1249,16 @@
             descendants.update(self._limbo_descendants(descendant))
         return descendants
 
-    def create_file(self, contents, trans_id, mode_id=None, sha1=None):
+    def create_file(self, contents, trans_id, mode_id=None):
         """Schedule creation of a new file.
 
-        :seealso: new_file.
-
-        :param contents: an iterator of strings, all of which will be written
-            to the target destination.
-        :param trans_id: TreeTransform handle
-        :param mode_id: If not None, force the mode of the target file to match
-            the mode of the object referenced by mode_id.
-            Otherwise, we will try to preserve mode bits of an existing file.
-        :param sha1: If the sha1 of this content is already known, pass it in.
-            We can use it to prevent future sha1 computations.
+        See also new_file.
+
+        Contents is an iterator of strings, all of which will be written
+        to the target destination.
+
+        New file takes the permissions of any existing file with that id,
+        unless mode_id is specified.
         """
         name = self._limbo_name(trans_id)
         f = open(name, 'wb')
@@ -1275,16 +1271,12 @@
                 f.close()
                 os.unlink(name)
                 raise
+
             f.writelines(contents)
         finally:
             f.close()
         self._set_mtime(name)
         self._set_mode(trans_id, mode_id, S_ISREG)
-        # It is unfortunate we have to use lstat instead of fstat, but we just
-        # used utime and chmod on the file, so we need the accurate final
-        # details.
-        if sha1 is not None:
-            self._observed_sha1s[trans_id] = (sha1, osutils.lstat(name))
 
     def _read_file_chunks(self, trans_id):
         cur_file = open(self._limbo_name(trans_id), 'rb')
@@ -1349,8 +1341,6 @@
     def cancel_creation(self, trans_id):
         """Cancel the creation of new file contents."""
         del self._new_contents[trans_id]
-        if trans_id in self._observed_sha1s:
-            del self._observed_sha1s[trans_id]
         children = self._limbo_children.get(trans_id)
         # if this is a limbo directory with children, move them before removing
         # the directory
@@ -1712,7 +1702,6 @@
         finally:
             child_pb.finished()
         self._tree.apply_inventory_delta(inventory_delta)
-        self._apply_observed_sha1s()
         self._done = True
         self.finalize()
         return _TransformResults(modified_paths, self.rename_count)
@@ -1838,47 +1827,17 @@
                             raise
                     else:
                         self.rename_count += 1
-                    # TODO: if trans_id in self._observed_sha1s, we should
-                    #       re-stat the final target, since ctime will be
-                    #       updated by the change.
                 if (trans_id in self._new_contents or
                     self.path_changed(trans_id)):
                     if trans_id in self._new_contents:
                         modified_paths.append(full_path)
                 if trans_id in self._new_executability:
                     self._set_executability(path, trans_id)
-                if trans_id in self._observed_sha1s:
-                    o_sha1, o_st_val = self._observed_sha1s[trans_id]
-                    st = osutils.lstat(full_path)
-                    self._observed_sha1s[trans_id] = (o_sha1, st)
         finally:
             child_pb.finished()
         self._new_contents.clear()
         return modified_paths
 
-    def _apply_observed_sha1s(self):
-        """After we have finished renaming everything, update observed sha1s
-
-        This has to be done after self._tree.apply_inventory_delta, otherwise
-        it doesn't know anything about the files we are updating. Also, we want
-        to do this as late as possible, so that most entries end up cached.
-        """
-        # TODO: this doesn't update the stat information for directories. So
-        #       the first 'bzr status' will still need to rewrite
-        #       .bzr/checkout/dirstate. However, we at least don't need to
-        #       re-read all of the files.
-        # TODO: If the operation took a while, we could do a time.sleep(3) here
-        #       to allow the clock to tick over and ensure we won't have any
-        #       problems. (we could observe start time, and finish time, and if
-        #       it is less than eg 10% overhead, add a sleep call.)
-        paths = FinalPaths(self)
-        for trans_id, observed in self._observed_sha1s.iteritems():
-            path = paths.get_path(trans_id)
-            # We could get the file_id, but dirstate prefers to use the path
-            # anyway, and it is 'cheaper' to determine.
-            # file_id = self._new_id[trans_id]
-            self._tree._observed_sha1(None, path, observed)
-
 
 class TransformPreview(DiskTreeTransform):
     """A TreeTransform for generating preview trees.
@@ -2543,7 +2502,7 @@
                     executable = tree.is_executable(file_id, tree_path)
                     if executable:
                         tt.set_executability(executable, trans_id)
-                    trans_data = (trans_id, tree_path, entry.text_sha1)
+                    trans_data = (trans_id, tree_path)
                     deferred_contents.append((file_id, trans_data))
                 else:
                     file_trans_id[file_id] = new_by_entry(tt, entry, parent_id,
@@ -2594,11 +2553,10 @@
         unchanged = dict(unchanged)
         new_desired_files = []
         count = 0
-        for file_id, (trans_id, tree_path, text_sha1) in desired_files:
+        for file_id, (trans_id, tree_path) in desired_files:
             accelerator_path = unchanged.get(file_id)
             if accelerator_path is None:
-                new_desired_files.append((file_id,
-                    (trans_id, tree_path, text_sha1)))
+                new_desired_files.append((file_id, (trans_id, tree_path)))
                 continue
             pb.update('Adding file contents', count + offset, total)
             if hardlink:
@@ -2611,7 +2569,7 @@
                     contents = filtered_output_bytes(contents, filters,
                         ContentFilterContext(tree_path, tree))
                 try:
-                    tt.create_file(contents, trans_id, sha1=text_sha1)
+                    tt.create_file(contents, trans_id)
                 finally:
                     try:
                         contents.close()
@@ -2620,13 +2578,13 @@
                         pass
             count += 1
         offset += count
-    for count, ((trans_id, tree_path, text_sha1), contents) in enumerate(
+    for count, ((trans_id, tree_path), contents) in enumerate(
             tree.iter_files_bytes(new_desired_files)):
         if wt.supports_content_filtering():
             filters = wt._content_filter_stack(tree_path)
             contents = filtered_output_bytes(contents, filters,
                 ContentFilterContext(tree_path, tree))
-        tt.create_file(contents, trans_id, sha1=text_sha1)
+        tt.create_file(contents, trans_id)
         pb.update('Adding file contents', count + offset, total)
 
 

